#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

const int INF = 1000000000;

int main() {
    int n, m;
    cin >> n >> m;
    
    int dist[18][18];
    fill(dist[0], dist[0]+18*18, INF);
    
    for(int i=0;i<m;i++) {
        int a, b, l;
        cin >> a >> b >> l;
        a--, b--;
        dist[a][b] = min(dist[a][b], l);
        dist[b][a] = min(dist[b][a], l);
    }
    
    static int dp[1<<18][18];
    fill(dp[0], dp[0] + (1<<18)*18, INF);
    dp[1][0] = 0;
    
    for(int comb = 1; comb < (1<<n); comb++) {
        for(int i=0;i<n;i++) {
            if((comb & 1<<i) != 0) {
                for(int j=0;j<n;j++) {
                    if(i != j && (comb & 1<<j) != 0) {
                        dp[comb][i] = min(dp[comb][i], dp[comb-(1<<i)][j] + dist[j][i]);
                    }
                }
            }
        }
    }
    
    int result = INF;
    for(int i=0;i<n;i++) {
        result = min(result, dp[(1<<n)-1][i] + dist[i][0]);
    }
    cout << result << '\n';
    return 0;
}